#include <iostream>

#include "i3d/image3d.h"
#include "threshold.h"

using namespace std;
using namespace i3d;


int main(void) {
	try {
		//chytani vyjimek, umoznuje zobrazit chybova hlaseni knihoven i3dlibs
		//tato konstrukce rika, ze v tomto bloku {...} se maji chytat vyjimky

		Image3d<GRAY8> img;

		//opens and reads GRAY 8bit only_2D image
		img.ReadImageBMP("images/cell01_2D_GRAY8.bmp");
		//or
		//opens and reads GRAY 8bit 2D or 3D image
		//img.ReadImageICS("images/cell01_2D_GRAY8.ics");

		cout << "Doing some thresholding.\n";
		Threshold(img,85);

		//saves the GRAY image
		img.SaveImageBMP("images/cell01_2D_GRAY8_thresholded.bmp");
		//img.SaveImageICS("images/cell01_2D_GRAY8_thresholded.ics");

		//pokud se program dostal az sem, nenastal zadny problem
		return(0);

	} //konec bloku "try" - chytani ruznych vyjimek
	catch (const char *e)
	{
		cout << e << endl;
	}
	catch (std::string &e)
	{
		cout << e << endl;
	}
	catch (i3d::IOException& e)
	{
		cout << e << endl;
	}
	catch (i3d::InternalException& e)
	{
		cout << e << endl;
	}
	catch (std::bad_alloc&)
	{
		cout << "Not enough memory." << endl;
	}
	catch (...)
	{
		cout << "System exception." << endl;
	}

	//pokud se program dostal sem, nastal predtim nejaky problem
	return(1);
}
